<template>
  <div
    v-if="isModerator"
    class="bottom-30"
  >
    <ObSelect
      v-model="ownerUuid"
      :required="true"
      :is-search="true"
      :is-auto-complete="false"
      :remote-opt="{
        method: getCarriers
      }"
      label="Владелец ресурса"
      placeholder="Выберите из списка или начните вводить название"
      value-exp="uuid"
      display-exp="title"
      popper-class="carriers-list"
      class="carriers-select"
      @selected="onSelect"
    />

    <template v-if="ownerInn">
      <span class="-gray-slate">ИНН: </span>
      <span class="-cobalt-black">{{ ownerInn }}</span>
    </template>
  </div>
</template>

<script>
  import api from '@/api'
  import { mapGetters } from 'vuex'
  import ObSelect from 'common-components/src/obComponents/obSelect'

  export default {
    name: 'OwnerField',
    components: {
      ObSelect
    },
    data () {
      return {
        ownerUuid: null,
        ownerInn: null
      }
    },
    computed: {
      ...mapGetters({
        isModerator: 'user/isModerator',
        participantUuid: 'user/participantUuid'
      })
    },
    methods: {
      async getCarriers ({ page, size, query }) {
        const response = await api.resources.getCarriers({ page, size, query })

        return {
          ...response,
          content: response.carriers.map((owner) => ({
            ...owner,
            icon: 'truck-sm',
            subtitle: owner.inn
          }))
        }
      },
      onSelect (item) {
        this.ownerInn = item.inn

        this.$emit('input', item.uuid)
      }
    }
  }
</script>

<style scoped>
  .carriers-select:not(:last-child) {
    margin-bottom: 10px;
  }
</style>

<style lang="scss">
  @import "~common-components/src/static/css/mixins";

  .carriers-list {
    .ob-selector__list-item {
      flex-direction: column;
    }

    .ob-selector__list-item-icon {
      margin-top: 2px;
    }

    .ob-selector__list-item-subtitle {
      @include font-mixin(12px, 14px, 400, $color-grey-label);

      margin: 2px 0 0 29px;
    }
  }
</style>